#include <bits/stdc++.h>

using namespace std;


bool safl(int n, int a, string t)
{
    int index = -1;
    for(int i = 0; i < n / 2; i++)
    {
        if(t[i] != t[(n - 1) - i])
        {
            index = i;
            break;
        }
    }

    if(index == -1)
        return true;

    int xtip[26];
    int ytip[26];

    memset(xtip, 0, sizeof(xtip));
    memset(ytip, 0, sizeof(ytip));


    if(index + a - 1 >= n - index - a)
    {
        for(int i = 0; i < a; i++)
        {
            xtip[t[index + i] - 'a']++;
            ytip[t[(n - index - a) + i] - 'a']++;
        }

        for(int i = 0; i < n - ((2 * index) + a) ; i++)
        {
            xtip[t[i + index + a] - 'a']--;
            ytip[t[i + index] - 'a']--;
        }

        int xgreska = 0;
        int ygreska = 0;

        bool xmoze = true;
        bool ymoze = true;

        for(int i = 0; i < 26; i++)
        {
            if(xtip[i] < 0)
                xmoze = false;
            else if(xtip[i] % 2 == 1)
                xgreska++;

            if(ytip[i] < 0)
                ymoze = false;
            else if(ytip[i] % 2 == 1)
                ygreska++;
        }

        if(xgreska > 1)
            xmoze = false;
        if(ygreska > 1)
            ymoze = false;

        if(xmoze || ymoze)
            return true;
        return false;
    }
    else
    {
        for(int i = 0; i < a; i++)
        {
            xtip[t[index + i] - 'a']++;
            ytip[t[(n - index - a) + i] - 'a']++;
        }

        for(int i = 0; i < 26; i++)
        {
            if(xtip[i] != ytip[i])
                return false;
        }

        return true;
    }
}

int main()
{
    string t;
    cin >> t;

    int n = t.length();

    int l = 1;
    int r = n - 1;

    int minstr;


    while(l <= r)
    {
        int mid = l + ((r - l) / 2);

        if(safl(n, mid, t))
        {
            minstr = mid;
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    cout << minstr << '\n';

    return 0;
}